#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import subprocess


def check_ldap_service():
    slapd_service = ["slapd.service", "keepalived.service"]
    for service in slapd_service:
        status_service = subprocess.call("systemctl status {}".format(service).split(), shell=False)
        is_enabled_service = subprocess.call("systemctl is-enabled {}".format(service).split(), shell=False)
        if status_service == 0:
            if is_enabled_service == 0:
                print("\033[32m[healthy]\033[0m[service check][ldap server][{}]: {} is running and enabled.".format(
                    service, service))
            elif is_enabled_service != 0:
                print("\033[91m[unhealthy]\033[0m[service check][ldap server][{}]: {} is not enabled.".format(service,
                                                                                                              service))
        elif status_service == 3:
            if is_enabled_service == 0:
                print("\033[91m[unhealthy]\033[0m[service check][ldap server][{}]: {} not running.".format(service,
                                                                                                           service))
            elif is_enabled_service != 0:
                print(
                    "\033[91m[unhealthy]\033[0m[service check][ldap server][{}]: {} not running and not enabled".format(
                        service, service))
        else:
            print("\033[91m[unhealthy]\033[0m[service check][ldap server][{}]: {} could not be found".format(service,
                                                                                                             service))
            continue


if __name__ == '__main__':
    check_ldap_service()
