#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
Obtain the NTP service Configuration of the Server Node.
"""
import os
import subprocess

return_message = {
    'ntp dependency package': 'UNINSTALLED',
    '/etc/ntp.conf': 'NULL',
    '/etc/ntp.conf master ip': 'NULL',
    '/etc/ntp.conf slave ip': 'NULL',
    'time zone': 'NULL'
}


def master_config_item():
    """
    获取三方件服务NTP主节点配置项
    :return:
    """
    process1 = subprocess.Popen(['/usr/bin/cat', '/etc/ntp.conf'], shell=False, stdout=subprocess.PIPE)
    process = subprocess.Popen(['/usr/bin/grep', '^server'], shell=False, stdin=process1.stdout, stdout=subprocess.PIPE)
    try:
        status = subprocess.check_output(['/usr/bin/grep', 'prefer$'], shell=False, stdin=process.stdout).decode(
            "utf-8").strip()
        return_message['/etc/ntp.conf master ip'] = status
    except subprocess.CalledProcessError:
        return_message['/etc/ntp.conf master ip'] = 'NULL'
    process.stdout.close()


def slave_config_item():
    """
    获取三方件服务NTP备节点配置项
    :return:
    """
    process1 = subprocess.Popen(['/usr/bin/cat', '/etc/ntp.conf'], shell=False, stdout=subprocess.PIPE)
    process = subprocess.Popen(['/usr/bin/grep', '^server'], shell=False, stdin=process1.stdout, stdout=subprocess.PIPE)
    try:
        status = subprocess.check_output(['/usr/bin/grep', 'iburst$'], shell=False, stdin=process.stdout).decode(
            "utf-8").strip()
        return_message['/etc/ntp.conf slave ip'] = status
    except subprocess.CalledProcessError:
        return_message['/etc/ntp.conf slave ip'] = 'NULL'
    process.stdout.close()


def get_ntp_items():
    """
    获取服务器节点三方件服务ntp配置项
    :return: 返回组织后的服务器节点三方件服务NTP配置项
    """
    # 获取系统时区信息
    status = subprocess.check_output(['/usr/bin/date', '+%Z'], shell=False).decode("utf-8").strip()
    return_message['time zone'] = status

    devnull = os.open(os.devnull, os.O_WRONLY, os.O_CREAT)
    try:
        subprocess.check_output(['/usr/bin/yum', 'list', 'installed', 'ntp'], shell=False, stderr=devnull)
        return_message['ntp dependency package'] = 'INSTALLED'
        os.close(devnull)
    except subprocess.CalledProcessError:
        os.close(devnull)
        return

    ntp_file = '/etc/ntp.conf'
    if not os.path.exists(ntp_file):
        return

    return_message[ntp_file] = 'EXIST'
    master_config_item()
    slave_config_item()


get_ntp_items()
print(return_message)
